10 REM C:\cbproj\CalcEd\moontrak_wb7cci.bas - MOON TRACKING PROGRAM
20 REM PROGRAM ORIGINATED BY WB7CCI. THIS VERSION CONVERTED TO DISC BASIC BY
30 REM G3RWL. WORKS OK WITH GWBASIC. LATER CONVERTED TO CalcEd BY DL4YHF.
40 REM
50 REM THIS PROGRAM PRINTS AZ/EL FIGURES AT SET INTERVALS. SAMPLE RUN FOR 31ST
60 REM DECEMBER 1983 COMMENCING 0100 UTC AND 30 MINUTE INTERVALS GAVE AOS AT
70 REM 0500 AZ=118.6 EL=-2.6 THRU MAXIMUM EL AT 0930 AZ=176.9 EL=18.2 TO LOS
80 REM AT 1430 AZ=241.3 EL=-4.2. USE THIS AS WORKED EXAMPLE WITH LAT/LONG AT
85 REM L5=51.65 deg (N) and L6=0.1 deg (E) BEFORE CHANGING TO *YOUR* QTH.
87 CLR : REM Added by WoBu, because CalcEd doesn't clear variables on 'run' !
90 P1=3.14159:PC=P1/180:PD=2*P1
100 DEF FNC(Z)=ATN(Z/SQR(-Z*Z+1)):REM ARCSIN
110 L5=51.65*PC : L6=0.1*PC : REM STATION LAT/LONG L5/L6
115 COLOR 14,0 : REM Set text- and background colour (VGA text mode)
120 CLS : PRINT TAB(25)"MoonTrack":PRINT TAB(25)"========="
125 PRINT " To modify observer position, edit LAT(";L5/PC;")/LON(";L6/PC;") in line 110." : PRINT
130 INPUT "Year number in full ",Y
131 IF Y=0 THEN Y=2005
140 IF Y<1980 OR Y>2099 OR Y<>INT(Y) THEN 130
150 INPUT "       Month number ",M
151 IF M=0 THEN M=10
160 IF M<1 OR M>12 OR M<>INT(M) THEN 150
170 INPUT "         Day number ",D
171 IF D=0 THEN D=19
180 IF D<1 OR D>31 OR D<>INT(D) THEN 170
190 M1=M+12:YA=Y-1:IF M>2 THEN M1=M:YA=Y
200 A=INT(Y/100):BZ=2-A+INT(A/4):J=INT(365.25*YA)+INT(30.6001*(M1+1))+D+BZ
210 INPUT "Start time UTC HHMM ",B
220 IF B<0 OR B>2400 OR B<>INT(B) THEN 210
230 PRINT:INPUT "Time step, default = 30 minutes ",ST
240 IF ST=0 THEN ST=30
250 PRINT "Stepping by";ST;" minutes"
260 REM INPUT "Type P for printer, V for vdu or B for both ",P$
265 REM IF P$="" THEN P$="V"
270 REM IF P$="b"THEN P$="B" ELSE IF P$="p"THEN P$="P" ELSE IF P$="v" THEN P$="V"
275 REM IF P$="B" OR P$="P" OR P$="V" THEN 290 ELSE 260
280 INPUT "press ENTER to continue",P$ : P$="V"
290 T1=J-17472.5-676553!:IF P$<>"P" THEN CLS
300 IF P$="V" OR P$="B" THEN CLS:PRINT TAB(21)"Moontrack by WB7CCI"
310 IF P$="P" OR P$="B" THEN LPRINT TAB(21)"Moontrack by WB7CCI"
320 IF P$="V" OR P$="B" THEN PRINT TAB(21)"===================":PRINT
330 IF P$="P" OR P$="B" THEN LPRINT TAB(21)"===================":LPRINT
340 IF P$="V" OR P$="B" THEN PRINT:PRINT TAB(20)"Date ";D;"/";M;"/";Y
350 IF P$="P" OR P$="B" THEN LPRINT:LPRINT TAB(20)"Date ";D;"/";M;"/";Y
360 IF P$="P" THEN PRINT:PRINT "Printout being produced":PRINT
370 GOSUB 930
380 D9=(B-((INT(B/100))*100))+INT(B/100)*60
390 T=D9/1440:T2=T1+T:X1=.751213+.0366011*T2
400 K1=(X1-INT(X1))*PD:X2=.822513+.0362917*T2
410 K2=(X2-INT(X2))*PD:X4=.974271+.0338632*T2
420 K4=(X4-INT(X4))*PD:X3=.995766+2.73779E-03*T2
430 K3=(X3-INT(X3))*PD:X5=.0312525+.0367482*T2
440 K5=(X5-INT(X5))*PD
450 L8=K1+(.658*SIN(2*K4)+6.289*SIN(K2))*PC
460 L8=L8-(1.274*SIN(K2-2*K4)+.186*SIN(K3))*PC
470 L8=L8+(.214*SIN(2*K2)-.114*SIN(2*K5))*PC
480 L8=L8-(.059*SIN(2*K2-2*K4)+.057*SIN(K2+K3-2*K4))*PC
490 K6=K5+(.6593*SIN(2*K4)+6.2303*SIN(K2-1.272)*SIN(K2-2*K4))*PC
500 L7=(5.144*SIN(K6)-.146*SIN(K5-2*K4))*PC
510 D1=COS(L7)*SIN(L8)*.397821+SIN(L7)*.917463:D1=FNC(D1)
520 A2=COS(L7)*COS(L8)/COS(D1)
530 A1=(COS(L7)*SIN(L8)*.917463-SIN(L7)*.397821)/COS(D1)
540 A=ATN(A1/A2):GOSUB 830:R1=A:L1=.0657098*T1
550 L=T*24*1.00274+6.64606+(L1-INT(L1/24)*24)
560 L=L-INT(L/24)*24:G=(L/24)*PD-R1:IF G<PD THEN 580
570 G=G-PD:GOTO 600
580 IF G<0 THEN 590 ELSE 600
590 G=G+PD
600 H=L6-G
610 E=COS(L5)*COS(H)*COS(D1)+SIN(D1)*SIN(L5):E=FNC(E)
620 A2=SIN(D1)/(COS(L5)*COS(E)):A2=A2-TAN(L5)*TAN(E)
630 A1=SIN(L5)*SIN(D1)+COS(L5)*COS(D1)*COS(H)
640 A1=(SIN(H)*COS(D1))/SQR(1-A1*A1):A=ATN(A1/A2):GOSUB 830
650 AZ=(INT(A*180/P1*10))/10:EL=(INT(E*180/P1*10))/10
660 IF EL<-20 THEN B=B+100
670 IF EL<-10 THEN B=B+85
680 IF EL<-5 THEN 710 ELSE GOSUB 910
690 IF P$="V" OR P$="B" THEN PRINT TAB(12)T$;TAB(26)AZ;TAB(41)EL
700 IF P$="P" OR P$="B" THEN LPRINT TAB(12)T$;TAB(26)AZ;TAB(41)EL
710 B=B+ST:B2=B-(INT(B/100))*100:IF B2>59 THEN B=B+40
720 IF B<2400 THEN 380
730 IF P$="V" OR P$="B" THEN PRINT
740 IF P$="P" OR P$="B" THEN LPRINT
750 INPUT "Next Day ? (Y/N) ",N$
760 IF LEFT$(N$,1)="Y" OR LEFT$(N$,1)="y" THEN 770 ELSE END
770 T1=T1+1:D=D+1:IF P$="V" OR P$="B" THEN PRINT:PRINT TAB(20)"Date: ";
780 IF P$="P" OR P$="B" THEN LPRINT:LPRINT TAB(20)"Date: ";
790 IF P$="V" OR P$="B" THEN PRINT D;"/";M;"/";Y
800 IF P$="P" OR P$="B" THEN LPRINT D;"/";M;"/";Y
810 IF P$="P" THEN PRINT:PRINT "Printout being produced":PRINT
820 GOSUB 930:B=B-2400:GOTO 380
830 IF A=0 THEN 840 ELSE 860
840 IF A2<0 THEN 850 ELSE RETURN
850 A=P1:RETURN
860 IF A>0 THEN 900
870 IF A2<0 THEN 890
880 A=A+PD:RETURN
890 A=A+P1:RETURN
900 IF A2>=0 THEN RETURN ELSE A=A+P1:RETURN
910 T$=STR$(B)
911 T$=RIGHT$(T$,(LEN(T$)-1))
920 T$=RIGHT$(("0000"+T$),4):RETURN
930 IF P$="V" OR P$="B" THEN PRINT TAB(12)"UTC";TAB(26)"Azimuth";TAB(42)"Elev"
940 IF P$="P" OR P$="B" THEN LPRINT TAB(12)"UTC";TAB(26)"Azimuth";TAB(42)"Elev"
950 RETURN
